// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/include/opto32_utils.h $
// $Rev: 53209 $
// $Date: 2023-06-20 08:51:55 -0500 (Tue, 20 Jun 2023) $

// OPTO32: Utilities: header file

#ifndef	__OPTO32_UTILS_H__
#define	__OPTO32_UTILS_H__

#include "opto32_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	opto32_close_util		(int fd, int index, int verbose);
int opto32_init_util		(int verbose);
int opto32_ioctl_util		(int fd, int index, int verbose, int request, void* arg);
int	opto32_open_util		(int device, int share, int index, int verbose, int* fd);
int opto32_read_util		(int fd, int index, int verbose, void* dst, size_t bytes, int* got);

// IOCTL utility services

int	opto32_clock_divider	(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_CLOCK_DIVIDER
int	opto32_cos_polarity		(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_COS_POLARITY
int	opto32_cos_state		(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_COS_STATE
int	opto32_debounce_ms		(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_DEBOUNCE_MS
int	opto32_debounce_us		(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_DEBOUNCE_US
int	opto32_initialize		(int fd, int index, int verbose);								// OPTO32_IOCTL_INITIALIZE
int	opto32_irq_enable		(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_IRQ_ENABLE
int	opto32_led				(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_LED
int	opto32_query			(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_QUERY
int	opto32_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// OPTO32_IOCTL_REG_MOD
int	opto32_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// OPTO32_IOCTL_REG_READ
int	opto32_reg_write		(int fd, int index, int verbose, u32 reg, u32 value);			// OPTO32_IOCTL_REG_WRITE
int	opto32_rx_data			(int fd, int index, int verbose, s32* get);						// OPTO32_IOCTL_RX_DATA
int	opto32_rx_event_counter	(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_RX_EVENT_COUNTER
int	opto32_tx_data			(int fd, int index, int verbose, s32 set, s32* get);			// OPTO32_IOCTL_TX_DATA
int	opto32_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// OPTO32_IOCTL_WAIT_CANCEL
int	opto32_wait_event		(int fd, int index, int verbose, gsc_wait_t* wait);				// OPTO32_IOCTL_WAIT_EVENT
int	opto32_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// OPTO32_IOCTL_WAIT_STATUS

// Auxiliary utility services

int opto32_id_device		(int fd, int index, int verbose);

int	opto32_count_boards		(int verbose, s32* get);
int	opto32_reg_list			(int fd, int detail);

const gsc_reg_def_t*		opto32_reg_get_def_id(u32 reg);
const gsc_reg_def_t*		opto32_reg_get_def_index(int index);
const char*					opto32_reg_get_desc(u32 reg);
const char*					opto32_reg_get_name(u32 reg);



#endif
