// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 51207 $
// $Date: 2022-06-30 11:06:15 -0500 (Thu, 30 Jun 2022) $

// OPTO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _debounce_resolution(void)
{
	gsc_label("Debounce Resolution");
	printf("200ns\n");
	return(0);
}



//*****************************************************************************
static int _input_qty(void)
{
	gsc_label("Isolated Inputs");
	printf("24\n");
	return(0);
}



//*****************************************************************************
static int _output_qty(void)
{
	gsc_label("Isolated Outputs");
	printf("8\n");
	return(0);
}



//*****************************************************************************
static int _id_device_mailbox(const args_t* args)
{
	int	errs	= 0;
	u32	field;
	u32	mbox;

	gsc_label("PLD Revision Level");
	errs	+= opto32_reg_read(args->fd, -1, 0, GSC_PLX_9056_MBOX0, &mbox);
	field	= mbox & 0xFFFF;
	printf("0x%04lX\n", (long) field);

	gsc_label("EEPROM Revision Level");
	field	= mbox >> 16;
	printf("0x%04lX\n", (long) field);

	gsc_label("Board Assy Revision");
	errs	+= opto32_reg_read(args->fd, -1, 0, GSC_PLX_9056_MBOX1, &mbox);
	field	= mbox >> 16;
	printf("0x%04lX\n", (long) field);

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= opto32_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _debounce_resolution();
	errs	+= _input_qty();
	errs	+= _output_qty();

	for (i = 0; i < OPTO32_IOCTL_QUERY_LAST; i++)
		errs	+= opto32_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_mailbox(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


