// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/samples/sbtest/debounce_ms.c $
// $Rev: 51211 $
// $Date: 2022-06-30 11:15:26 -0500 (Thu, 30 Jun 2022) $

// OPTO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_DEBOUNCE_MS,
			/* arg		*/	0,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_DEBOUNCE_MS,
			/* arg		*/	1,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	3332
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_DEBOUNCE_MS,
			/* arg		*/	22,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	73665L
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_DEBOUNCE_MS,
			/* arg		*/	333,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	1109999L
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_DEBOUNCE_MS,
			/* arg		*/	2000,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	6666665L
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= opto32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= service_ioctl_set_get_list(fd, list);
	errs	+= opto32_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Additional equipment is required to test this.
	return(0);
}



/******************************************************************************
*
*	Function:	debounce_ms_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service OPTO32_IOCTL_DEBOUNCE_MS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int debounce_ms_test(int fd)
{
	int	errs	= 0;

	gsc_label("OPTO32_IOCTL_DEBOUNCE_MS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


