// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/samples/sbtest/initialize.c $
// $Rev: 51211 $
// $Date: 2022-06-30 11:15:26 -0500 (Thu, 30 Jun 2022) $

// OPTO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There is no initializa bit to exercise.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{				//	Adjust the input buffer threshold.
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	0xAAAAAA
		},
		{				//	Make sure the value is correct.
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	0xAAAAAA
		},
		{				//	Perform the initialization.
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	OPTO32_IOCTL_INITIALIZE,
			/* arg		*/	0,
			/* reg		*/	OPTO32_GSC_CDR,
			/* mask		*/	0xFFFFFF,
			/* value	*/	0x000000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= opto32_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= opto32_initialize(fd, -1, 0);

	return(errs);
}



/******************************************************************************
*
*	Function:	initialize_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service OPTO32_IOCTL_INITIALIZE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int initialize_test(int fd)
{
	int	errs	= 0;

	gsc_label("OPTO32_IOCTL_INITIALIZE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


