// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/samples/sbtest/query.c $
// $Rev: 51211 $
// $Date: 2022-06-30 11:15:26 -0500 (Thu, 30 Jun 2022) $

// OPTO32: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	errs	= opto32_query(fd, -1, 0, (int) OPTO32_QUERY_COUNT, &count);

	if (count != (int) OPTO32_IOCTL_QUERY_LAST)
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) OPTO32_IOCTL_QUERY_LAST,
				(long) count);
	}

	for (i = 0; (errs == 0) && (i < (int) OPTO32_IOCTL_QUERY_LAST); i++)
		errs	= opto32_query(fd, -1, 0, i, &data);

	return(errs);
}



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service OPTO32_IOCTL_QUERY.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	int	errs	= 0;

	gsc_label("OPTO32_IOCTL_QUERY");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


