// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/utils/util_cos_state.c $
// $Rev: 53202 $
// $Date: 2023-06-20 08:47:04 -0500 (Tue, 20 Jun 2023) $

// OPTO32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	opto32_cos_state
*
*	Purpose:
*
*		Provide a visual wrapper for the OPTO32_IOCTL_COS_STATE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int opto32_cos_state(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;
	s32	was	= set;

	if (verbose)
		gsc_label_index("COS State", index);

	ret		= opto32_ioctl(fd, OPTO32_IOCTL_COS_STATE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf(	"%s  (%s: 0x%06lX)\n",
				errs ? "FAIL <---" : "PASS",
				(was == -1) ? "Active" : "Clear",
				(long) set);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


