// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/utils/util_debounce_us.c $
// $Rev: 43524 $
// $Date: 2018-09-06 20:24:34 -0500 (Thu, 06 Sep 2018) $

// OPTO32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	opto32_debounce_us
*
*	Purpose:
*
*		Provide a visual wrapper for the OPTO32_IOCTL_DEBOUNCE_US service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int opto32_debounce_us(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Debounce Period (us)", index);

	ret		= opto32_ioctl(fd, OPTO32_IOCTL_DEBOUNCE_US, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (%ld us)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


