// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/OPTO32/OPTO32_Linux_7.x.x.x_GSC_DN/utils/util_rx_data.c $
// $Rev: 51233 $
// $Date: 2022-06-30 17:49:26 -0500 (Thu, 30 Jun 2022) $

// OPTO32: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	opto32_rx_data
*
*	Purpose:
*
*		Provide a visual wrapper for the OPTO32_IOCTL_RX_DATA service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int opto32_rx_data(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("Rx Data", index);

	ret		= opto32_ioctl(fd, OPTO32_IOCTL_RX_DATA, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%06lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


